<?php

define('IN_COPPERMINE', true);
define('ADDPIC_PHP', true);

require('include/init.inc.php');
require('include/picmgmt.inc.php');

if (!GALLERY_ADMIN_MODE) die('Access denied');

ob_end_flush();

register_shutdown_function('reload');

function cleanupfilelist() {
	global $filelist, $CONFIG;

	$sql = "SELECT user4 FROM {$CONFIG['TABLE_PICTURES']} WHERE user4 <> '' ORDER BY aid ASC";
    $result = cpg_db_query($sql);
	$cnt = count($filelist);
	$dbcnt = mysql_num_rows($result);
	while($row = mysql_fetch_row($result)) {
		unset($filelist[$row[0]]);
	}
	flush();

	echo $cnt . " NEW Remote Pictures Found<br />";
	echo $dbcnt . " Remote Pictures in the database<br />";
	echo "After filtering " . count($filelist) . " pictures will be added<br />";
}


function populatealbums()
{
	global $filelist, $counter;
	
	$lim = $_POST['hardlimit'] > 0 ? $_POST['hardlimit'] : getrandmax();
		
	foreach ($filelist as $url => $arr)
	{
		if ($counter < $lim)
		{
			set_time_limit(180);
			//echo "$filename - $aid<br />";
			addpic($url, $arr[0], $arr[1]);
			unset($filelist[$url]);
			usleep($_POST['sleep'] * 1000);
			$counter++;
		}
	}
}

function createstructure($path) {
	$aid = 0;
	$parent = 0;
	$npath = trim(preg_replace('/[^a-zA-Z0-9\/\@\.\-_]/', ' ', $path));
	// validate path and create it if required
	if ( substr($npath,0,1) == "/" && $npath != "/" ) {
		$npath = trim($npath,"/");
		$arr = explode("/",$npath);
		$npath = "";
		for ($i = 0; $i < count($arr); $i++) {
			// Skip if name is empty
			if ( $arr[$i] != "" ) {
				// rebuild the new path
				$npath .= "/" . trim($arr[$i]);

				// create category
				if ( $i < count($arr)-1 ) {
					$parent = createcategory($parent, trim($arr[$i]), $npath);
					
					// if an error occured, return with error
					if ( $parent == -1 ) {
						echo "WARNING: An error occured while creating the category : " . $npath . "<br \>This path will be discarded. No pictures in this path will be added !!<br \>";
						return array(-1, "");
					}

				// create album
				} else {
					$aid = createalbum($parent, trim($arr[$i]), $npath);

					// if an error occured, return with error
					if ( $aid == -1 ) {
						echo "WARNING: An error occured while creating the album : " . $npath . "<br \>This path will be discarded. No pictures in this path will be added !!<br \>";
						return array(-1, "");
					}
				}
			}
		}
	}
	return array($aid, $npath);
}

function createcategory($parent, $name, $path)
{
	global $CONFIG;

	// check if the directory already exists
	if ( ! is_dir(trim($CONFIG['fullpath'],"/") . $path) ) {
		//create the new directory or exit with error
		if ( ! mkdir(trim($CONFIG['fullpath'],"/") . $path, 0750) ) return -1;
	}

	$sql = "SELECT cid " . "FROM {$CONFIG['TABLE_CATEGORIES']} " . "WHERE name='" . addslashes($name) . "' AND parent=" . (INT)$parent . " LIMIT 1";
    $result = cpg_db_query($sql);

    if (mysql_num_rows($result)) {
		echo "Category already exists: " . $name . "<br />";
		$row = mysql_fetch_row($result);
		$cid = $row[0];
	} else {
		cpg_db_query("INSERT INTO {$CONFIG['TABLE_CATEGORIES']} (pos, parent, name) VALUES ('10000', '$parent', '" . addslashes($name) . "')");
		echo "Category Created: " . $name . "<br/>";
		$cid = mysql_insert_id();
	}
	flush();

	return $cid;
}

function createalbum($category, $title, $path)
{
	global $CONFIG;

	// check if the directory already exists
	if ( ! is_dir(trim($CONFIG['fullpath'],"/") . $path) ) {
		//create the new directory or exit with error
		if ( ! mkdir(trim($CONFIG['fullpath'],"/") . $path, 0750) ) return -1;
	}

	$sql = "SELECT aid " . "FROM {$CONFIG['TABLE_ALBUMS']} " . "WHERE title='" . addslashes($title) . "' AND category=" . (INT)$category . " LIMIT 1";
    $result = cpg_db_query($sql);

    if (mysql_num_rows($result)) {
		echo "Album already exists: " . $title . "<br />";
		$row = mysql_fetch_row($result);
		$aid = $row[0];
	} else {
		cpg_db_query("INSERT INTO {$CONFIG['TABLE_ALBUMS']} (category, title, pos) VALUES ('".(INT)$category."', '" . addslashes($title) . "', '10000')");
		echo "Album Created:" . $title . "<br />";
		$aid = mysql_insert_id();
	}
	flush();

	return $aid;
}

function buildfilelist($data) {
	global $filelist;

	// init starting album id / path
	$aid = 0;
	$path = "/";
	foreach ( $data as $key => $value ) {
		$value = trim($value);
		// new localtion, build location structure, get album id
		if ( substr($value,0,1) == "/" ) {
			list($aid, $path) = createstructure($value);
		// new entry
		} else {
			// skip pictures in erroneous path
			if ( $aid > 0 ) {
				if ( strtolower(substr($value,0,4)) == "http" ) {
					$filelist[$value] = array($aid, $path);
					echo "Adding to list: " . $value . "<br \>";
				} else {
					echo "Unknow entry (ignored): " . $value . "<br \>";
				}
			}
		}
	}
}


function addpic($url, $aid, $path)
{
	global $CONFIG;

	// Open Remote File
	$dataFile = fopen( $url, "rb" );
	if ( $dataFile )
	{
		// Build local path 
		if ( $path != "/" ) {
			$fullpath = trim($CONFIG['fullpath'],"/") . $path . "/";
		} else {
			$fullpath = $CONFIG['fullpath'];
		}
		// Sanitize the local file name
		$sane_name = str_replace('%20', '_', basename($url));
		$sane_name = preg_replace('/[^a-zA-Z0-9\.\-_]/', '_', $sane_name);
		$sane_name = preg_replace('/[^a-zA-Z0-9\.\-_]/', '_', $sane_name);
		while ( strpos($sane_name,'__') != FALSE ) {
			$sane_name = str_replace('__', '_', $sane_name);
		}

		// Make sure the file has not been already added, based on the source url, destination directory and the sanitized local filename
		$sql = "SELECT pid " . "FROM {$CONFIG['TABLE_PICTURES']} " . "WHERE filepath='" . addslashes(ltrim($path,"/")."/") . "' AND filename='" . addslashes($sane_name) . "' AND user4='" . addslashes($url) . "' LIMIT 1";
		$result = cpg_db_query($sql);
		if (mysql_num_rows($result)) {
			echo "Picture already added: " . $url . " to path: " . $path . "<br />";
		} else {
			// Build the destination file full path
			$destimage = $fullpath . $sane_name;
			$c = 0;
			while ( file_exists($destimage) )
			{
				$c++;
				$destimage = $fullpath . $c . '_' . $sane_name;
			}

			// Open the destination file for writing.
			$fpw = fopen($destimage, "xb");
			if ( $fpw ) {
				while (!feof($dataFile)) {
				   $buffer = fgets($dataFile, 8192);
					if (fwrite($fpw, $buffer, strlen($buffer)) === 'FALSE') {
						fclose($fpw);
						unlink($destimage);
						break;
					}
				}
				if ( is_resource($fpw) === true ) {
					fclose($fpw);
				}
			}

			// Add the picture 
			if ( file_exists($destimage) ) {			
				if ( add_picture($aid, ltrim($path,"/")."/", basename($destimage), 0, '', '', '', '', '', '', $url) ) {
					echo "Remote Picture added: " . $url . " as File: " . $destimage . "<br />";

					// Remove Fullsize image.
					unlink($destimage);
					touch($destimage);
					
				} else {
					echo "Remote Picture failed: " . $url . " as File: " . $destimage . "<br />"; 
					unlink($destimage);
				}
			} else {
				echo "Error ! The Remote File could not be added: " . $url . "<br />";
			}
		}
		flush();
		ob_end_flush();
	} else {
		echo "Error ! The Remote File could not be accessed: " . $url . "<br />";
	}
	fclose($dataFile);
}


function reload()
{
	global $filelist, $counter;
	
	if (count($_POST) == 0) exit();
	
	$remaining = count($filelist);

	if ( $remaining > 0 ) {
	
		$filelist = base64_encode(serialize($filelist));
		$auto = (isset($_POST['auto']) && $_POST['auto']) ? 'checked = "checked"' : '';
		$js = ($_POST['auto'] && $remaining) ? '<script type="text/javascript"> onload = document.form.submit();</script>' : ''; 
		$counter = $counter ? "$counter files added" : "structure created";
		$sleep = isset($_POST['sleep'])  ? $_POST['sleep'] : '1000';
		$hardlimit = isset($_POST['hardlimit'])  ? $_POST['hardlimit'] : '0';

		$scriptname = $_SERVER['SCRIPT_NAME'];
		
		if (!connection_aborted()) echo <<< EOT
		
		$counter, $remaining files to add.<br />
		<form name="form" method="POST" action="$scriptname">
			<input name="filelist" type="hidden" value="$filelist">
			Sleep: <input type="text" name="sleep" value="$sleep">
			Limit: <input type="text" name="hardlimit" value="$hardlimit">
			<input type="submit" value="continue">
			Autorun: <input type="checkbox" name="auto" value="1" $auto>
		</form>
		$js
EOT;

	} else {
		if (!connection_aborted()) echo <<< EOT
			<br />Back to the main form : <a href="$scriptname">Back</a>

EOT;
	}
}
	
function countup($array)
{
	$result = 0;

	foreach ($array as $a)
		$result += is_array($a) ? countup($a) : count($a);

	return $result;
}


if (isset($_POST['filelist'])){

	$filelist = unserialize(base64_decode($_POST['filelist']));
	$counter = 0;
	
	populatealbums();

} elseif (isset($_POST['start'])) {

	// Test for a blank file upload box.
	if ( !empty($_FILES['file_upload_array']['tmp_name'][0]) && is_uploaded_file($_FILES['file_upload_array']['tmp_name'][0]) ) {

		echo "File Uploaded : " . $_FILES['file_upload_array']['tmp_name'][0] . "<br />";	
		echo "File Size : " . $_FILES['file_upload_array']['size'][0] . "<br />";	
		$data = file($_FILES['file_upload_array']['tmp_name'][0]);

		buildfilelist($data);

		cleanupfilelist();

	} else {

		echo "Nothing Uploaded.<br>";
	}
} else {
	$scriptname = $_SERVER['SCRIPT_NAME'];
	echo <<< EOT

<form method="POST" action="$scriptname" ENCTYPE="multipart/form-data">
	List of Remote Files to add: <input type="file" name="file_upload_array[]" size="40"><br /><br />
	Sleep between additions (ms): <input type="text" name="sleep" value="1000"><br /><br />
	Run unattended: <input type="checkbox" name="auto" value="1"><br /><br />
	Limit additions per refresh<input type="text" name="hardlimit" value="10"><br /><br />
	<input type="submit" name="start" value="Begin">
</form>

EOT;
}
?>